﻿namespace AirBomber
{
    internal class AirplaneCompareByType : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            var xAirplane = (DrawningAirplane?)(x as DrawningObject);
            var yAirplane = (DrawningAirplane?)(y as DrawningObject);
            if (xAirplane == yAirplane)
            {
                return 0;
            }
            if (xAirplane == null)
            {
                return 1;
            }
            if (yAirplane == null)
            {
                return -1;
            }
            if (xAirplane.GetType().Name != yAirplane.GetType().Name)
            {
                if (xAirplane.Airplane.GetType() == typeof(DrawningAirplane))
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xAirplane.Airplane.Speed.CompareTo(yAirplane.Airplane.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xAirplane.Airplane.Weight.CompareTo(yAirplane.Airplane.Weight);
        }
    }
}